Imports System.Text
Public Class TreeNodeListBoxItem
    Private Shared IconWidth As Integer = 19

    Private m_Node As TreeNode
    Private m_Height As Integer = 0
    Private m_Top As Integer = 0

    Public Sub New(ByVal Node As TreeNode)
        m_Node = Node
    End Sub

    Public Property Height() As Integer
        Get
            Return m_Height
        End Get
        Set(ByVal Value As Integer)
            m_Height = Value
        End Set
    End Property

    Property Top() As Integer
        Get
            Return m_Top
        End Get
        Set(ByVal value As Integer)
            m_Top = value
        End Set
    End Property

    Public ReadOnly Property Node() As TreeNode
        Get
            Return m_Node
        End Get
    End Property

    Public Function CalculateHeight(ByVal g As Graphics, ByVal Ft As Font, ByVal Width As Integer) As Integer

        Dim LinesFilled, CharsFitted As Integer

        ' Draw layout, 2 times the offset (left & right)
        Dim sz As New SizeF(Width - IconWidth, Ft.Height)

        Dim sbTextToDraw As New StringBuilder(m_Node.Text)
        Dim strLineToDraw As String
        Dim index1 As Integer = 0
        Dim lines As Integer = 0
        Dim index2, index2New As Integer

        While sbTextToDraw.Length > 0
            ' Break string into more lines when an end-of-line character is found
            index2 = sbTextToDraw.ToString().IndexOf(vbLf)
            If index2 > 0 Then
                strLineToDraw = sbTextToDraw.ToString(index1, index2 - index1)
                index2New = index2 + 1
            Else
                index2 = sbTextToDraw.Length
                index2New = index2
                strLineToDraw = sbTextToDraw.ToString()
            End If

            g.MeasureString(strLineToDraw, Ft, sz, StringFormat.GenericDefault, CharsFitted, LinesFilled)

            ' There's no knowledge about words, so just don't split words up if possible
            If CharsFitted < index2 Then
                Dim index As Integer = strLineToDraw.LastIndexOf(" "c, CharsFitted - 1, CharsFitted)
                If index <> -1 Then
                    index2New = index + 1
                Else
                    index2New = CharsFitted
                End If
            End If
            lines += LinesFilled
            sbTextToDraw = sbTextToDraw.Remove(index1, index2New)
        End While

        m_Height = lines * Ft.Height + 3
        Return m_Height
    End Function

    Public Sub Draw(ByVal g As Graphics, ByVal IL As ImageList, ByVal Bounds As Rectangle, ByVal Ft As Font)

        Dim TextBrush As SolidBrush
        If m_Node.IsSelected Then
            TextBrush = SystemBrushes.HighlightText
            g.FillRectangle(SystemBrushes.Highlight, New Rectangle(0, Bounds.Top, Bounds.Width, m_Height))
        Else
            TextBrush = Brushes.Black
        End If

        'draw image
        If IL IsNot Nothing Then
            IL.Draw(g, Bounds.Left + 1, Bounds.Top, m_Node.ImageIndex)
        End If




        'draw main text
        Dim LinesFilled As Integer = 0
        Dim CharsFitted As Integer = 0


        ' Draw layout, 2 times the offset (left & right)
        Dim oneLine As New SizeF(Bounds.Width - IconWidth, Ft.Height)

        Dim sbTextToDraw As New StringBuilder(m_Node.Text)
        Dim strLineToDraw As String
        Dim index1 As Integer = 0
        Dim index2, index2New As Integer
        Dim TmpTop As Integer = Bounds.Top + 1

        While sbTextToDraw.Length > 0
            ' Break string into more lines when an end-of-line character is found
            index2 = sbTextToDraw.ToString().IndexOf(vbLf)
            If index2 > 0 Then
                strLineToDraw = sbTextToDraw.ToString(index1, index2 - index1)
                index2New = index2 + 1
            Else
                index2 = sbTextToDraw.Length
                index2New = index2
                strLineToDraw = sbTextToDraw.ToString()
            End If

            g.MeasureString(strLineToDraw, Ft, oneLine, StringFormat.GenericDefault, CharsFitted, LinesFilled)

            ' There's no knowledge about words, so just don't split words up if possible
            If CharsFitted < index2 Then
                Dim index As Integer = strLineToDraw.LastIndexOf(" "c, CharsFitted - 1, CharsFitted)
                If index <> -1 Then
                    index2New = index + 1
                Else
                    index2New = CharsFitted
                End If
                strLineToDraw = sbTextToDraw.ToString(index1, index2New - index1)
            End If

            ' Draw the text
            g.DrawString(strLineToDraw, Ft, TextBrush, Bounds.Left + IconWidth, TmpTop)

            ' Adjust top
            TmpTop += Ft.Height

            ' Next line
            sbTextToDraw = sbTextToDraw.Remove(index1, index2New)
        End While

    End Sub


End Class
